#version 460
#extension GL_NV_gpu_shader5 : enable

in vec2 f_texcoord;
layout(packed, binding=0) buffer image {
	uint8_t color[];
}  ; // No local name for this one

out vec4 outcolor;

uniform uint width;
uniform uint height;

void main(void) {
	uint tex_x = uint(f_texcoord.x * float(width));
	uint tex_y = uint(f_texcoord.y * float(height));
	if(tex_y >= height)
		tex_y = height - 1;
	uint pixnum = tex_y * width + tex_x;
	outcolor.r = color[0 + 4 * pixnum]/255.0f;
	outcolor.g = color[1 + 4 * pixnum]/255.0f;
	outcolor.b = color[2 + 4 * pixnum]/255.0f;
	outcolor.a = 1.0f;

}
